function [x,iter]=ERDIBIKETA(beheX,goiX,tol,FunFcn)
// ERDIBIKETAk funtzio baten erroak aurkitzen ditu "erdibiketa" metodoaren bitartez.
//
// Kalkulua egiteko funtzioa (Funcfcn), tartearen behe- (beheX) eta goi-muturrak (goiX) eman behar zaizkio.
// ERDIBIKETAK erroa behin eta berriz kalkulatzen du errorea eskatutako tolerantzia (tol) baino txikiago izan arte.

// tol=[] bada, berez 1E-06 balioa hartzen du.
// tolerantzi ez bada emanten berez 1e-6 balioa hartzen du
if argn(2)<4 then tol = 1e-6; end
if tol==0 then tol=1e-6; end
// Iterazio kopuru maximoa ezartzeko aldagaiak
itermax=1000;
iter=0;
errorea=tol*100;
// behe- eta goi-muturren funtzioaren baliaok kalkultzen ditu.
fbehe=feval(beheX,FunFcn); fgoi=feval(goiX,FunFcn);
// Aukeraturiko tartean emaitza posible bat dagoen konprobatzen du
if (fbehe*fgoi)<0 then;
   //ziklo zikloko eragiketak egiten ditu errorea eskatutako tolerantziaren adinakoa izan arte
   while errorea>tol & iter<=itermax;
      // iterazio bat gehitzen du eta tartearen erdiko balioa eta funtzioarenak kalkulatzen ditu
      iter=iter+1; x=(goiX+beheX)/2; fx=feval(x,FunFcn);
      // bi erdi-tarteen artean emaitzan non dagoen arakatzen du
      if (fx*fbehe<0) then;
        // behe-mutura eta erdiko balioaren artean badago, erdiko balio hori goi-mutur bihurtzen da
        goiX=x;
        // goi-mutur eta erdiko balioaren artean badago, erdiko balio hori behe-mutur bihurtzen da
        else beheX=x;
      end
    errorea=abs(goiX-beheX)
   end
	if iter>=itermax disp('1000 iterazio ondoren ez du emaitzarik aurkitu');end
else disp('Tarte honetan ez dago errorik');
  x=NaN
  iter=0
    // emaitzarik ez badu aurkitzen "NaN: Non a Number" esaten digu
   //x=NaN;
end

endfunction
